---
stages:
  - pre-commit
  - test-suite
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID == null

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

variables:
  CICD_UPSTREAM_PATH: "vmware/pop/pop"

.test-suite:
  stage: test-suite
  needs:
    - pre-commit-run-all
  script:
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days
  after_script:
    - cicd/upload-code-coverage.sh

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.9-macos1015:
  extends: .test-suite
  tags:
    - vmw-macos-catalina
  rules:
    - if: "$CI_PROJECT_PATH == $CICD_UPSTREAM_PATH"
      when: on_success

tests-3.9-windows:
  extends: .test-suite
  tags:
    - vmw-macos-catalina
  rules:
    - if: "$CI_PROJECT_PATH == $CICD_UPSTREAM_PATH"
      when: on_success

tests-3.10:
  extends: .test-suite
  image: python:3.10

tests-3.11:
  extends: .test-suite
  image: python:3.11
